Payment Gateway
Integrate with Razorpay Payment Gateway.
Other Razorpay Products
Integrate with other Razorpay products using API sample codes.
Integrate With Razorpay Payment Gateway
Start accepting domestic payments from customers on your website using the Razorpay Payment Gateway. Razorpay has developed the Standard Checkout method and manages it. You can configure payment methods, orders, company logo and also select custom colour based on your convenience. Razorpay supports these payment methods.Sample App
We recommend you check the Python Sample App, created using the video tutorial.
GitHub Repository
Download the latest razorpay-python.zip file from GitHub. It is pre-compiled to include all dependencies.
Handy TipsYou can also download the Razorpay Python Test App directly from github.
Project Structure
Before you begin, we recommend you check the Python Sample App, and verify that your project contains the following files:
Before you proceed:
- Create a Razorpay Curlec account.
- Generate the API Keys from the Dashboard. To go live with the integration and start accepting real payments, generate Live Mode API Keys and replace them in the integration.
- Know about the Payment Flow and follow these integration steps:
1. Build Integration
Integrate with your Python-based website.
2. Test Integration
Test the integration by making a test payment.
3. Go-live Checklist
Check the go-live checklist.
1. Build Integration
1 Create an Order in Server
1 Create an Order in Server
Order is an important step in the payment process.
- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the Order with the payment and secures the request from being tampered.
Handy TipsYou can capture payments automatically with the Payment Capture setting configuration on the Dashboard.
1.1 Sample Code
1.1 Sample Code
Create a file, for example,
app.py and add the API code given below:1.2 Request Parameters
1.2 Request Parameters
Here is the list of parameters for creating an order:
amount mandatory
: integer The amount to be paid by the customer in sen. For example, if the amount is ₹500, enter 50000.currency mandatory
: string The currency in which the payment should be made by the customer. Length must be of 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7000 is to be received from the customer in two installments of #1 - ₹5000, #2 - ₹2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.1.3 Response Parameters
1.3 Response Parameters
Descriptions for the response parameters are present in the Orders Entity table.
1.4 Error Response Parameters
1.4 Error Response Parameters
The error response parameters are available in the API Reference Guide.
2 Add Checkout Options
2 Add Checkout Options
Add the Razorpay Checkout options to your project. For example, if you are using HTML for your front-end, create a page called index.html and and add the Pay button on your web page using the checkout code and either the callback URL or handler function.
Possible value is
2.1 Callback URL or Handler Function
2.1 Callback URL or Handler Function
Handy Tips
For FPX payments, you must use the Callback URL sample code for checkout. You should send the following parameters along with the other checkout parameters:
For FPX payments, you must use the Callback URL sample code for checkout. You should send the following parameters along with the other checkout parameters:
callback_urlwith the URL to which customers should be redirected after payment completion.redirectwith the value astrue.
2.3 Checkout Options
2.3 Checkout Options
key mandatory
: string API Key ID generated from the Dashboard.amount mandatory
: integer The amount to be paid by the customer in sen. For example, if the amount is , enter 222250.currency mandatory
: string The currency in which the payment should be made by the customer. Length must be of 3 characters.name mandatory
: string Your Business/Enterprise name shown on the Checkout form. For example, Acme Corp.description optional
: string Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.image optional
: string Link to an image (usually your business logo) shown on the Checkout form. Can also be a base64 string if you are not loading the image from a network.order_id mandatory
: string Order ID generated via Orders API.prefill
: object You can prefill the following details at Checkout.Boost Conversions and Minimise Drop-offs
- Autofill customer contact details, especially phone number to ease form completion. Include customer’s phone number in the
contactparameter of the JSON request’sprefillobject. Format: +(country code)(phone number). Example: “contact”: “+603112345678”. - This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.
name optional
: string Cardholder’s name to be prefilled if customer is to make card payments on Checkout. For example, Siti Aisyah.email optional
: string Email address of the customer.contact optional
: string Phone number of the customer. The expected format of the phone number is + {country code}{phone number}. If the country code is not specified, 60 will be used as the default value. This is particularly important while prefilling contact of customers with phone numbers issued outside Malaysia. Examples:- +14155552671 (a valid non-Malaysian number)
- +603112345678 (a valid Malaysian number).
If 1113455567 is entered without the country code,+60is added to it as +601113455567.
method optional
: string Pre-selection of the payment method for the customer. Will only work if contact and email are also prefilled. Possible value is
card.notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).theme
: object Thematic options to modify the appearance of Checkout.color optional
: string Enter your brand colour’s HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.backdrop_color optional
: string Enter a HEX code to change the Checkout’s backdrop colour.modal
: object Options to handle the Checkout modal.backdropclose optional
: boolean Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values:true: Closes the form when your customer clicks outside the checkout form.false(default): Does not close the form when customer clicks outside the checkout form.
escape optional
: boolean Indicates whether pressing the escape key should close the Checkout form. Possible values:true(default): Closes the form when the customer presses the escape key.false: Does not close the form when the customer presses the escape key.
handleback optional
: boolean Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values:true(default): Checkout behaves similarly to the browser. That is, when the browser’s back button is pressed, the Checkout also simulates a back press. This happens as long as the Checkout modal is open.false: Checkout does not simulate a back press when browser’s back button is pressed.
confirm_close optional
: boolean Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values:true: Confirmation dialog box is shown.false(default): Confirmation dialog box is not shown.
ondismiss optional
: function Used to track the status of Checkout. You can pass a modal object with ondismiss: function()\{\} as options. This function is called when the modal is closed by the user. If retry is false, the ondismiss function is triggered when checkout closes, even after a failure.animation optional
: boolean Shows an animation before loading of Checkout. Possible values:true(default): Animation appears.false: Animation does not appear.
subscription_id optional
: string If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant subscription_id to the Checkout. Know more about Subscriptions on Checkout.subscription_card_change optional
: boolean Permit or restrict customer from changing the card linked to the subscription. You can also do this from the hosted page. Possible values:true: Allow the customer to change the card from Checkout.false(default): Do not allow the customer to change the card from Checkout.
callback_url optional
: string Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted. This parameter is mandatory for FPX payments.redirect optional
: boolean Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. callback_url and redirect parameters are mandatory for FPX payments. Possible values:true: Customer is redirected to the specified callback URL in case of payment failure. For FPX payments, theredirectparameter should always be sent astrue.false(default): Customer is shown the Checkout popup to retry the payment.
customer_id optional
: string Unique identifier of customer.remember_customer optional
: boolean Determines whether to allow saving of cards. Can also be configured via the Dashboard. Possible values:true: Enables card saving feature.false(default): Disables card saving feature.
timeout optional
: integer Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.readonly
: object Marks fields as read-only.contact optional
: boolean Used to set the contact field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
email optional
: boolean Used to set the email field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
name optional
: boolean Used to set the name field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
hidden
: object Hides the contact details.contact optional
: boolean Used to set the contact field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
email optional
: boolean Used to set the email field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
send_sms_hash optional
: boolean Used to auto-read OTP for cards. Applicable from Android SDK version 1.5.9 and above. Possible values:true: OTP is auto-read.false(default): OTP is not auto-read.
allow_rotation optional
: boolean Used to rotate payment page as per screen orientation. Applicable from Android SDK version 1.6.4 and above. Possible values:true: Payment page can be rotated.false(default): Payment page cannot be rotated.
config optional
: object Parameters that enable checkout configuration. Know more about how to configure payment methods on Razorpay standard checkout.display
: object Child parameter that enables configuration of checkout display language.language
: string The language in which checkout should be displayed. Possible value is en: English.Handy TipsThe open method of Razorpay object (
rzp1.open()) must be invoked by your site’s JavaScript, which may or may not be a user-driven action such as a click.2.4 Handle Payment Success and Failure
2.4 Handle Payment Success and Failure
The way the Payment Success and Failure scenarios are handled depends on the Checkout Sample Code you used in the last step.
Checkout with Callback URL
Checkout with Callback URL
If you used the sample code with the callback URL:
- On Payment Success
- On Payment Failure
Razorpay makes a POST call to the callback URL with the razorpay_payment_id, razorpay_order_id and razorpay_signature in the response object of the successful payment. Only successful authorisations are auto-submitted.
Checkout with Handler Function
Checkout with Handler Function
If you used the sample code with the handler function:Use the Success/Failure Handling code given below:
- On Payment Success
- On Payment Failure
The customer sees your website page. The checkout returns the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature). Collect these and send them to your server.
2.5 Configure Payment Methods *(Optional)*
2.5 Configure Payment Methods *(Optional)*
Multiple payment methods are available on Razorpay Standard Checkout.
- The payment methods are fixed and cannot be changed.
- You can configure the order or make certain payment methods prominent. Know more about configuring payment methods. Know more about configuring payment methods.
3 Store Fields in Your Server
3 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form.
Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.4 Verify Payment Signature
4 Verify Payment Signature
This is a mandatory step that allows you to confirm the authenticity of the details returned to the checkout for successful payments.To verify the
razorpay_signature returned to you by the checkout:- Create a signature in your server using the following attributes:
- Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:
-
If the signature you generate on your server matches the
razorpay_signaturereturned to you by the checkout, the payment received is from an authentic source. Use the code given below to generate signature on your server:
Verify Payment Signature
5 Verify Payment Status
5 Verify Payment Status
Handy TipsOn the Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.- Verify Status from Dashboard
- Subscribe to Webhook Events
- Poll APIs
To verify the payment status from the Dashboard:
- Log in to the Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app. Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful. Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others may require approval from us. Raise a request from the Dashboard to enable such payment methods.
You can make test payments using one of the payment methods configured at the Checkout.
FPX
FPX
You can select any of the listed banks. After choosing a bank, Razorpay Curlec will redirect to a mock page where you can make the payment a
success or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.Wallet
Wallet
You can select any of the listed wallets. After choosing a wallet, you will be redirected to a mock page where you can make the payment
success or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.Cards
Cards
You can use one of the following test cards to test transactions for your integration in Test Mode.
Check the following lists:
3. Go-live Checklist
Check the go-live checklist for Razorpay Web Standard Checkout integration. Consider these steps before taking the integration live.1 Accept Live Payments
1 Accept Live Payments
Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.To generate API Keys in Live Mode on your Razorpay Dashboard:
- Log in to the Razorpay Dashboard and switch to Live Mode on the menu.
- Navigate to Account & Settings → API Keys → Generate Key to generate the API Key for Live Mode.
- Download the keys and save them securely.
- Replace the Test API Key with the Live Key in the Checkout code and start accepting actual payments.
2 Payment Capture
2 Payment Capture
After payment is
authorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.- Auto-capture Payments (Recommended)
- Manually Capture Payments
Authorized payments can be automatically captured. You can auto-capture all payments using global settings on the Razorpay Dashboard. Know more about capture settings for payments.
3 Set Up Webhooks
3 Set Up Webhooks
Ensure you have set up webhooks in the live mode and configured the events for which you want to receive notifications.